package com.hys.app.service.erp;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.hys.app.framework.database.mybatisplus.base.BaseService;
import com.hys.app.model.erp.entity.*;

import java.math.BigDecimal;

/**
 * 部门 Service 接口
 */
public interface CompanyManager extends BaseService<Company> {
    /**
     * 创建公司
     *
     * @param companyDO
     * @return
     */
    String createCompany(CompanyDO companyDO);

    /**
     * 修改公司
     *
     * @param companyUpdateDO
     * @param id
     * @return
     */
    Long updateCompany(CompanyUpdateDO companyUpdateDO, Long id);

    /**
     * 公司续费
     *
     * @param companyUpdateDO
     * @param id
     * @return
     */
    Long renewCompany(CompanyRenewDO companyUpdateDO, Long id);

    /**
     * 获取公司详情
     *
     * @param id
     * @return
     */
    CompanyVO getOneCompany(Long id);

    /**
     * 分页
     *
     * @param query
     * @return
     */
    IPage<CompanyVO> getPage(CompanyQuery query);

    /**
     * 更改套餐获取差价
     *
     * @param id
     * @return
     */
    BigDecimal renewCompanyDifference(Long id);
}
